<template lang="pug">
  .sync.ph3.pv4.mw8.center
    h1.f3.b 資料同步狀況
    .flex.flex-wrap
      .sync__item.pr3.pb3(v-for="service in serviceList" :key="service.id")
        .br3.ba.b--gray.bg-white.pa3
          .pb3.bb.b--gray.b [{{service.label}}]
          .mv3.gray.f6 最後更新：{{showUpdatedAt(service)}}
          .tr
            b-button(
              type="is-success"
              size="is-small"
              @click="syncService(service)"
              :loading="isThisServiceInSync(service)"
              :disabled="isOtherServiceInSync(service)"
            ) 馬上更新

</template>
<script>
import moment from 'moment'
import { airsync, feathers } from '~/utils/api'

const SERVICE_LIST = [
  { id: 'ticket', label: '通報', updatedAt: 0 },
  { id: 'booking', label: '室友註冊表', updatedAt: 0 },
  { id: 'canned-msg', label: '罐頭訊息', updatedAt: 0 },
  { id: 'bot-msg', label: '機器人訊息', updatedAt: 0 },
  { id: 'ticket-state', label: '內外狀態對照', updatedAt: 0 },
  { id: 'holiday', label: '假日清單', updatedAt: 0 },
  { id: 'slack-mapping', label: 'Slack 通知設定', updatedAt: 0 },
  { id: 'slack-hook', label: 'Slack 綁定設定', updatedAt: 0 }
]

const ALL_SERVICE_NAME = 'ALL_TABLES'

const TIMER_UPDATE_PERIOD = 30 * 1000

export default {
  layout: 'private',
  data () {
    return {
      serviceList: SERVICE_LIST,
      globalUpdatedAt: 0,
      currentSync: null,
      timestampTimer: null
    }
  },
  created () {
    this.getUpdatedAt()
    this.initWs()
  },
  beforeDestroy () {
    this.closeWs()
  },
  methods: {
    updateTimestamp (task) {
      if (task.status !== 'succeeded') {
        return false
      }
      if (task.service === ALL_SERVICE_NAME) {
        this.globalUpdatedAt = moment(task.updatedAt)
        return true
      }
      const service = this.serviceList.find(service => service.id === task.service)
      if (service) {
        const newTime = moment(task.updatedAt)
        if (newTime > service.updatedAt) {
          service.updatedAt = newTime
        }
      }
    },
    async getUpdatedAt () {
      const resp = await airsync.find({
        $limit: 50,
        $sort: { updatedAt: -1 }
      })
      resp.data.some((task) => {
        // iterate the list until we got successful ALL_SERVICE
        return this.updateTimestamp(task)
      })
    },
    showUpdatedAt (service) {
      const time = service.updatedAt > this.globalUpdatedAt ? service.updatedAt : this.globalUpdatedAt
      if (time === 0) {
        return ''
      }
      return time.fromNow()
    },
    async syncService (service) {
      this.currentSync = service.id
      let result = null
      try {
        result = await airsync.sync(service.id)
      } catch (err) {
        console.error(err)
      }
      if (!result || result.status !== 'succeeded') {
        this.$buefy.snackbar.open(`下載 ${service.label} 暫時失敗，請稍後再試`)
      }
      this.currentSync = null
    },
    isThisServiceInSync (task) {
      return this.currentSync === task.id
    },
    isOtherServiceInSync (task) {
      return this.currentSync && !this.isThisServiceInSync(task)
    },
    initWs () {
      this.createdHandler = (rows) => {
        if (Array.isArray(rows)) {
          rows.forEach(row => this.updateTimestamp(row))
        } else {
          this.updateTimestamp(rows)
        }
      }
      feathers.service('airsync').on('created', this.createdHandler)
      this.timestampTimer = setInterval(() => {
        // just to trigger proxy update
        this.globalUpdatedAt = this.globalUpdatedAt.clone().add(1, 'ms')
      }, TIMER_UPDATE_PERIOD)
    },
    closeWs () {
      feathers.service('airsync').off('created', this.createdHandler)
      clearInterval(this.timestampTimer)
    }
  }
}
</script>
<style lang="scss" scoped>
.sync {
  &__item {
    width: 33%;
    min-width: 10rem;
  }
}
</style>
